import { __decorate, __param } from 'tslib';
import { ViewChild, Input, Component, Host, Renderer2, ElementRef, ComponentFactoryResolver, ViewContainerRef, Directive, NgModule } from '@angular/core';
import { NgbCalendar, NgbInputDatepicker } from '@ng-bootstrap/ng-bootstrap';

import * as ɵngcc0 from '@angular/core';
import * as ɵngcc1 from '@ng-bootstrap/ng-bootstrap';

const _c0 = ["defaultDayTemplate"];
function DayComponent_ng_template_0_Template(rf, ctx) { if (rf & 1) {
    ɵngcc0.ɵɵelementStart(0, "span", 1);
    ɵngcc0.ɵɵtext(1);
    ɵngcc0.ɵɵelementEnd();
} if (rf & 2) {
    const date_r2 = ctx.$implicit;
    const currentMonth_r3 = ctx.currentMonth;
    const selected_r4 = ctx.selected;
    const focused_r6 = ctx.focused;
    const ctx_r1 = ɵngcc0.ɵɵnextContext();
    ɵngcc0.ɵɵclassProp("weekend", ctx_r1.highlightWeekend && ctx_r1.isWeekend(date_r2))("disabled", ctx_r1.isWeekend(date_r2))("focused", focused_r6)("bg-primary", selected_r4)("outside", date_r2.month !== currentMonth_r3)("text-muted", date_r2.month !== currentMonth_r3);
    ɵngcc0.ɵɵadvance(1);
    ɵngcc0.ɵɵtextInterpolate1(" ", date_r2.day, " ");
} }
let DayComponent = class DayComponent {
    constructor(calendar) {
        this.calendar = calendar;
        this.highlightWeekend = false;
        this.isDisabled = (date, current) => date.month !== current.month;
        this.isWeekend = (date) => this.calendar.getWeekday(date) >= 6;
    }
};
DayComponent.ɵfac = function DayComponent_Factory(t) { return new (t || DayComponent)(ɵngcc0.ɵɵdirectiveInject(ɵngcc1.NgbCalendar)); };
DayComponent.ɵcmp = ɵngcc0.ɵɵdefineComponent({ type: DayComponent, selectors: [["app-day"]], viewQuery: function DayComponent_Query(rf, ctx) { if (rf & 1) {
        ɵngcc0.ɵɵstaticViewQuery(_c0, true);
    } if (rf & 2) {
        var _t;
        ɵngcc0.ɵɵqueryRefresh(_t = ɵngcc0.ɵɵloadQuery()) && (ctx.defaultDayTemplate = _t.first);
    } }, inputs: { highlightWeekend: "highlightWeekend" }, decls: 2, vars: 0, consts: [["defaultDayTemplate", ""], [1, "custom-day"]], template: function DayComponent_Template(rf, ctx) { if (rf & 1) {
        ɵngcc0.ɵɵtemplate(0, DayComponent_ng_template_0_Template, 2, 13, "ng-template", null, 0, ɵngcc0.ɵɵtemplateRefExtractor);
    } }, styles: [".custom-day[_ngcontent-%COMP%]{text-align:center;padding:.185rem .25rem;border-radius:.25rem;display:inline-block;width:2rem}.custom-day.focused[_ngcontent-%COMP%], .custom-day[_ngcontent-%COMP%]:hover{background-color:#e6e6e6}.weekend[_ngcontent-%COMP%]{border-radius:1rem;color:red}.hidden[_ngcontent-%COMP%]{display:none}span.disabled[_ngcontent-%COMP%]{border-radius:1rem}.ngb-dp-day.disabled[_ngcontent-%COMP%]   span.disabled[_ngcontent-%COMP%]{background-color:#00f!important}"] });
DayComponent.ctorParameters = () => [
    { type: NgbCalendar }
];
__decorate([
    ViewChild('defaultDayTemplate', { static: true })
], DayComponent.prototype, "defaultDayTemplate", void 0);
__decorate([
    Input()
], DayComponent.prototype, "highlightWeekend", void 0);

let CustomDatePickerDirective = class CustomDatePickerDirective {
    constructor(_picker, calendar, _renderer, _elRef, _cfr, _vcRef) {
        this._picker = _picker;
        this.calendar = calendar;
        this._renderer = _renderer;
        this._elRef = _elRef;
        this._cfr = _cfr;
        this._vcRef = _vcRef;
        this.option = {};
        this.disableWeekend = false;
        this.highlightWeekend = false;
    }
    ngOnChanges(changes) {
        if (!changes.option.isFirstChange()) {
            this.dayComp.instance.highlightWeekend = changes.option.currentValue.highlightWeekend;
            this._picker.dayTemplate = this.dayComp.instance.defaultDayTemplate;
            if (changes.option.currentValue.disableWeekend) {
                this.isWeekendDisabled = (date, current) => this.calendar.getWeekday(date) >= 6;
                this._picker.markDisabled = this.isWeekendDisabled;
            }
            else {
                this._picker.markDisabled = null;
            }
        }
    }
    ngOnInit() {
        const cf = this._cfr.resolveComponentFactory(DayComponent);
        this.dayComp = this._vcRef.createComponent(cf);
        this.dayComp.instance.highlightWeekend = this.option.highlightWeekend;
        this._picker.dayTemplate = this.dayComp.instance.defaultDayTemplate;
        if (this.option.disableWeekend) {
            this.isWeekendDisabled = (date, current) => this.calendar.getWeekday(date) >= 6;
            this._picker.markDisabled = this.isWeekendDisabled;
        }
    }
};
CustomDatePickerDirective.ɵfac = function CustomDatePickerDirective_Factory(t) { return new (t || CustomDatePickerDirective)(ɵngcc0.ɵɵdirectiveInject(ɵngcc1.NgbInputDatepicker, 1), ɵngcc0.ɵɵdirectiveInject(ɵngcc1.NgbCalendar), ɵngcc0.ɵɵdirectiveInject(ɵngcc0.Renderer2), ɵngcc0.ɵɵdirectiveInject(ɵngcc0.ElementRef), ɵngcc0.ɵɵdirectiveInject(ɵngcc0.ComponentFactoryResolver), ɵngcc0.ɵɵdirectiveInject(ɵngcc0.ViewContainerRef)); };
CustomDatePickerDirective.ɵdir = ɵngcc0.ɵɵdefineDirective({ type: CustomDatePickerDirective, selectors: [["input", "ngbDatepicker", ""]], inputs: { option: "option", disableWeekend: "disableWeekend", highlightWeekend: "highlightWeekend" }, features: [ɵngcc0.ɵɵNgOnChangesFeature] });
CustomDatePickerDirective.ctorParameters = () => [
    { type: NgbInputDatepicker, decorators: [{ type: Host }] },
    { type: NgbCalendar },
    { type: Renderer2 },
    { type: ElementRef },
    { type: ComponentFactoryResolver },
    { type: ViewContainerRef }
];
__decorate([
    Input()
], CustomDatePickerDirective.prototype, "option", void 0);
__decorate([
    Input()
], CustomDatePickerDirective.prototype, "disableWeekend", void 0);
__decorate([
    Input()
], CustomDatePickerDirective.prototype, "highlightWeekend", void 0);
CustomDatePickerDirective = __decorate([ __param(0, Host())
], CustomDatePickerDirective);

let BSSuperDatePickerModule = class BSSuperDatePickerModule {
};
BSSuperDatePickerModule.ɵmod = ɵngcc0.ɵɵdefineNgModule({ type: BSSuperDatePickerModule });
BSSuperDatePickerModule.ɵinj = ɵngcc0.ɵɵdefineInjector({ factory: function BSSuperDatePickerModule_Factory(t) { return new (t || BSSuperDatePickerModule)(); }, imports: [[]] });
/*@__PURE__*/ (function () { ɵngcc0.ɵsetClassMetadata(DayComponent, [{
        type: Component,
        args: [{
                selector: 'app-day',
                template: " \n\n  <ng-template #defaultDayTemplate let-date let-currentMonth=\"currentMonth\" let-selected=\"selected\" let-disabled=\"disabled\" let-focused=\"focused\">\n    <span class=\"custom-day\" [class.weekend]=\"highlightWeekend && isWeekend(date)\" [class.disabled]=\"isWeekend(date)\" [class.focused]=\"focused\"\n          [class.bg-primary]=\"selected\" [class.outside]=\"date.month !== currentMonth\" [class.text-muted]=\"date.month !== currentMonth\">\n     {{ date.day }}\n    </span>\n  </ng-template>",
                styles: [".custom-day{text-align:center;padding:.185rem .25rem;border-radius:.25rem;display:inline-block;width:2rem}.custom-day.focused,.custom-day:hover{background-color:#e6e6e6}.weekend{border-radius:1rem;color:red}.hidden{display:none}span.disabled{border-radius:1rem}.ngb-dp-day.disabled span.disabled{background-color:#00f!important}"]
            }]
    }], function () { return [{ type: ɵngcc1.NgbCalendar }]; }, { highlightWeekend: [{
            type: Input
        }], defaultDayTemplate: [{
            type: ViewChild,
            args: ['defaultDayTemplate', { static: true }]
        }] }); })();
/*@__PURE__*/ (function () { ɵngcc0.ɵsetClassMetadata(CustomDatePickerDirective, [{
        type: Directive,
        args: [{
                selector: `input[ngbDatepicker]`
            }]
    }], function () { return [{ type: ɵngcc1.NgbInputDatepicker, decorators: [{
                type: Host
            }] }, { type: ɵngcc1.NgbCalendar }, { type: ɵngcc0.Renderer2 }, { type: ɵngcc0.ElementRef }, { type: ɵngcc0.ComponentFactoryResolver }, { type: ɵngcc0.ViewContainerRef }]; }, { option: [{
            type: Input
        }], disableWeekend: [{
            type: Input
        }], highlightWeekend: [{
            type: Input
        }] }); })();
(function () { (typeof ngJitMode === "undefined" || ngJitMode) && ɵngcc0.ɵɵsetNgModuleScope(BSSuperDatePickerModule, { declarations: [DayComponent,
        CustomDatePickerDirective], exports: [DayComponent,
        CustomDatePickerDirective] }); })();
/*@__PURE__*/ (function () { ɵngcc0.ɵsetClassMetadata(BSSuperDatePickerModule, [{
        type: NgModule,
        args: [{
                declarations: [DayComponent, CustomDatePickerDirective],
                imports: [],
                exports: [DayComponent, CustomDatePickerDirective]
            }]
    }], null, null); })();

/*
 * Public API Surface of bssuper-date-picker
 */

/**
 * Generated bundle index. Do not edit.
 */

export { BSSuperDatePickerModule, CustomDatePickerDirective, DayComponent };

//# sourceMappingURL=bssuper-date-picker.js.map